
#include <cstdio>
#include <iostream>
#include <algorithm>
using namespace std;

const int MAXM = 262144;

struct event
{
    int b, e;
    
    inline bool operator < (const event &rhs) const
    {
        if (b != rhs.b)
            return b < rhs.b;
        return e > rhs.e;
    }
};

int N, M;
event e [MAXM];
long long am [MAXM];

inline long long query (int pos)
{
    long long res = 0;
    for (int i = pos; i > 0; i -= (i & -i))
        res += am [i];
    return res;
}
inline void update (int pos, int val)
{
    for (int i = pos; i < MAXM; i += (i & -i))
        am [i] += val;
}

void read ()
{
    scanf ("%d %d", &N, &M);
    for (int i = 0; i < M; ++i)
        scanf ("%d %d", &e [i].b, &e [i].e);
}

long long solve ()
{
//    printf ("Here?");
    sort (e, e + M);
    long long res = 0;
    for (int i = 0; i < M; ++i)
    {
//        for (int j = 1; j <= N; ++j)
//            printf ("%lld ", query (j) - query (j - 1));
//        puts ("");
//        printf ("sum [%d, %d] ..\n", e [i].e - 1, e [i].b);
        res += max (0LL, query (e [i].e - 1) - query (e [i].b));
//        printf ("%lld\n", res);
        update (e [i].e, 1);
    }
    return res;
}

int main ()
{
    read ();
//    printf ("%lld\n", solve ());
    cout << solve () << endl;
    return 0;
}
