
#include <cstdio>
#include <string>
#include <iostream>
using namespace std;

int perm [3][6] = {{5, 1, 4, 3, 0, 2}, 
                   {1, 2, 3, 0, 4, 5}, 
                   {0, 4, 2, 5, 3, 1}};

int out [3][4] = {{-1, 4, -1, -1}, {3, 0, 1, 2}, {-1, 5, -1, -1}};
                   
struct Cube
{
    string side [6][3];
    
    void read (char grid [9][12])
    {
        for (int i = 0; i < 3; ++i)
            for (int j = 0; j < 4; ++j)
                if (out [i][j] >= 0)
                {
                    for (int k = 0; k < 3; ++k)
                    {
                        side [out [i][j]][k] = "";
                        for (int z = 0; z < 3; ++z)
                            side [out [i][j]][k] += string (1, grid [i * 3 + k][j * 3 + z]);
                    }
                }
    }
    
    void print (char grid [9][12])
    {
        for (int i = 0; i < 9; ++i)
            for (int j = 0; j < 12; ++j)
                grid [i][j] = ' ';
        
        for (int i = 0; i < 3; ++i)
            for (int j = 0; j < 4; ++j)
                if (out [i][j] >= 0)
                {
                    for (int x = 0; x < 3; ++x)
                        for (int y = 0; y < 3; ++y)
                            grid [i * 3 + x][j * 3 + y] = side [out [i][j]][x][y];
                }
    }
    
    void rotate (char ch)
    {
        string nside [6][3];
        for (int i = 0; i < 6; ++i)
            for (int j = 0; j < 3; ++j)
                nside [perm [ch - 'x'][i]][j] = side [i][j];
        for (int i = 0; i < 6; ++i)
            for (int j = 0; j < 3; ++j)
                side [i][j] = nside [i][j];
    }
    
    void rotateUpBy90 ()
    {
        // First flip the upper side by 90 degrees.
        char tmp [3][3];
        for (int i = 0; i < 3; ++i)
            for (int j = 0; j < 3; ++j)
                tmp [2 - j][i] = side [4][i][j];
        for (int i = 0; i < 3; ++i)
            for (int j = 0; j < 3; ++j)
                side [4][i][j] = tmp [i][j];
        
        char ntmp [4][3];
        for (int i = 0; i < 4; ++i)
            for (int j = 0; j < 3; ++j)
                ntmp [i][j] = side [i][0][j];
        for (int i = 0; i < 4; ++i)
            for (int j = 0; j < 3; ++j)
                side [(i + 1) % 4][0][j] = ntmp [i][j];
    }
};

Cube rube;

char grid [9][12];

void read ()
{
    memset (grid, 0, sizeof (grid));
    string cur;
    for (int i = 0; i < 9; ++i)
    {
        getline (cin, cur);
        for (int j = 0; j < min (12, (int) cur.size ()); ++j)
            grid [i][j] = cur [j];
    }
}
int main ()
{
    read ();
    rube.read (grid);
//    rube.rotateUpBy90 ();
//    memset (grid, '#', sizeof (grid));
//    rube.print (grid);
    
    string cmd;
    cin >> cmd;
    for (int i = 0; i < (int) cmd.size (); ++i)
    {
        char ch = cmd [i];
        if (ch >= 'x' && ch <= 'z')
        {
//            if (ch == 'x')
//                for (int j = 0; j < 3; ++j)
//                    rube.rotate (ch);
            rube.rotate (ch);
        }
        else
        {
            while (ch > '0')
            {
                rube.rotateUpBy90 ();
                --ch;
            }
        }
        
//        memset (grid, '#', sizeof (grid));
//        rube.print (grid);
        
//        for (int i = 0; i < 9; ++i, puts (""))
//            for (int j = 0; j < 12; ++j)
//                putchar (grid [i][j]);
//        puts ("");
//        puts ("");
    }
    
    rube.print (grid);
    for (int i = 0; i < 9; ++i, puts (""))
        for (int j = 0; j < 12; ++j)
            putchar (grid [i][j]);
    return 0;
}
