#include <cstdio>
#include <cstdlib>

#define LOW_BIT(i) ((i)&(-(i)))

#define MAXN 262144

#define ull unsigned long long

int tree[MAXN];

void update(int pos, int num) {
	for(int i = pos; i < MAXN; i += LOW_BIT(i)) {
		tree[i] += num;
	}
}
int query(int pos) {
	int sum = 0;
	for(int i = pos; i >= 1; i -= LOW_BIT(i)) {
		sum += tree[i];
	}
	return sum;
}
int query(int from, int to) {
	if(from >= to) return 0;
	return query(to) - query(from-1);
}

int N, M;
int inter[MAXN][2];
void input() {
	scanf("%d%d", &N, &M);
	int tmp;
	for(int i = 0; i < M; ++i) {
		scanf("%d%d", &inter[i][0], &inter[i][1]);
		if(inter[i][0] > inter[i][1]) {
			tmp = inter[i][0];
			inter[i][0] = inter[i][1];
			inter[i][1] = tmp;
		}
	}
}

int cmp(const void *_a, const void *_b) {
	int* a = (int*)_a;
	int* b = (int*)_b;
	
	return b[1] - b[0] - a[1] + a[0];
	
}
int main() {
	input();
	qsort(inter, M, sizeof(inter[0]), cmp);
	
	ull cross = 0;
	
	for(int i = 0; i < M; ++i) {
		cross += query(inter[i][0]+1, inter[i][1]-1);
		update(inter[i][0], 1);
		update(inter[i][1], 1);
	}
	printf("%llu\n", cross);
	return 0;
}
