#include <cstdio>
#include <vector>

typedef std :: vector<char> row;
typedef std :: vector<row>  side;
typedef std :: vector<side> cube;

cube c(6, side(3, row(3)));
char s[10000000];

cube read()
{
	cube c(6, side(3, row(3)));
	char s[20];
	for(int i = 0; i < 3; i ++)
	{
		scanf("%s", s);
		for(int j = 0; j < 3; j ++)		c[4][i][j] = s[j];
	}
	for(int i = 0; i < 3; i ++)
	{
		scanf("%s", &s);
		for(int j = 0; j < 3; j ++)		c[3][i][j] = s[j];
		for(int j = 3; j < 6; j ++)		c[0][i][j - 3] = s[j];
		for(int j = 6; j < 9; j ++)		c[1][i][j - 6] = s[j];
		for(int j = 9; j < 12; j ++)	c[2][i][j - 9] = s[j];
	}
	for(int i = 0; i < 3; i ++)
	{
		scanf("%s", s);
		for(int j = 0; j < 3; j ++)		c[5][i][j] = s[j];
	}
	return c;
}

void write(cube c)
{
	for(int i = 0; i < 3; i ++)
	{
		printf("   ");
		for(int j = 0; j < 3; j ++)		printf("%c", c[4][i][j]);
		printf("\n");
	}
	for(int i = 0; i < 3; i ++)
	{
		for(int j = 0; j < 3; j ++)		printf("%c", c[3][i][j]);
		for(int j = 0; j < 3; j ++)		printf("%c", c[0][i][j]);
		for(int j = 0; j < 3; j ++)		printf("%c", c[1][i][j]);
		for(int j = 0; j < 3; j ++)		printf("%c", c[2][i][j]);
		printf("\n");
	}
	for(int i = 0; i < 3; i ++)
	{
		printf("   ");
		for(int j = 0; j < 3; j ++)		printf("%c", c[5][i][j]);
		printf("\n");
	}
	printf("\n");
}

cube rotateX(cube a)
{
	cube res = a;
	res[0] = a[4], res[5] = a[0];
	for(int i = 0; i < 3; i ++)
		for(int j = 0; j < 3; j ++)
			res[4][i][j] = a[2][2 - i][2 - j], res[2][i][j] = a[5][2 - i][2 - j];
	for(int i = 0; i < 3; i ++)
		for(int j = 0; j < 3; j ++)
			res[1][i][j] = a[1][j][2 - i], res[3][i][j] = a[3][2 - j][i];
	return res;
}

cube rotateY(cube a)
{
	cube res = a;
	res[0] = a[3], res[1] = a[0], res[2] = a[1], res[3] = a[2];
	for(int i = 0; i < 3; i ++)
		for(int j = 0; j < 3; j ++)
			res[4][i][j] = a[4][j][2 - i], res[5][i][j] = a[5][2 - j][i];
	return res;
}

cube rotateZ(cube a)
{
	cube res = a;
	for(int i = 0; i < 3; i ++)
		for(int j = 0; j < 3; j ++)
			res[4][i][j] = a[1][j][2 - i], res[5][i][j] = a[3][j][2 - i], res[3][i][j] = a[4][j][2 - i], res[1][i][j] = a[5][j][2 - i];
	for(int i = 0; i < 3; i ++)
		for(int j = 0; j < 3; j ++)
			res[0][i][j] = a[0][j][2 - i], res[2][i][j] = a[2][2 - j][i];
	return res;
}

cube rotateU(cube a)
{
	cube res = a;
	for(int i = 0; i < 3; i ++)
		for(int j = 0; j < 3; j ++)
			res[4][i][j] = a[4][j][2 - i];
	res[0][0] = a[3][0], res[1][0] = a[0][0], res[2][0] = a[1][0], res[3][0] = a[2][0];
	return res;
}

cube move(cube c)
{
	int l = strlen(s);
	for(int i = 0; i < l; i ++)
	{
		if( s[i] == 'x' )		c = rotateX(c);
		else if( s[i] == 'y' )	c = rotateY(c);
		else if( s[i] == 'z' )	c = rotateZ(c);
		else
			for(int j = 0; j < s[i] - '0'; j ++)
				c = rotateU(c);
	}
	return c;
}

int main()
{
	c = read();
	scanf("%s", s);
	c = move(c);
	write(c);
    return 0;
}
