#include <cstdio>
#include <algorithm>
using namespace std;

int perm[8][8] = {
  { 4 , 1 , 5 , 3 , 2 , 0 } ,
  { 3 , 0 , 1 , 2 , 4 , 5 } ,
  { 0 , 5 , 2 , 4 , 1 , 3 } 
};

char a[8][4][4];
char b[8][4][4];
char t[4][4];
 
void read() {
	int i , j;
	
	for (j=0;j<3;j++)
		scanf ("%s",a[4][j]);
	getchar();
	
	for (j=0;j<3;j++) {
		for (i=0;i<3;i++) scanf ("%c",&a[3][j][i]);
		for (i=0;i<3;i++) scanf ("%c",&a[0][j][i]);
		for (i=0;i<3;i++) scanf ("%c",&a[1][j][i]);
		for (i=0;i<3;i++) scanf ("%c",&a[2][j][i]);
		getchar();
	}
	
	for (j=0;j<3;j++)
		scanf ("%s",a[5][j]);
	getchar();
}

void flip ( int x ) {
	int i;
	
	for (i=0;i<3;i++)
		swap ( a[x][0][i] , a[x][2][i] );
	for (i=0;i<3;i++)
		swap ( a[x][i][0] , a[x][i][2] );
}

void rot1 ( int x ) {
	int i , j;
	
	t[1][1] = a[x][1][1];
	for (i=0;i<3;i++) {
		t[0][i] = a[x][2 - i][0];
		t[i][2] = a[x][0][i];
		t[2][i] = a[x][2 - i][2];
		t[i][0] = a[x][2][i];
	}
	
	for (i=0;i<3;i++)
		for (j=0;j<3;j++)
			a[x][i][j] = t[i][j];
}

void rot2 ( int x ) {
	rot1 ( x ); rot1 ( x ); rot1 ( x );
}

void turn1() {
	int i;
	
	for (i=0;i<3;i++) t[0][i] = a[3][0][i];
	for (i=0;i<3;i++) a[3][0][i] = a[2][0][i];
	for (i=0;i<3;i++) a[2][0][i] = a[1][0][i];
	for (i=0;i<3;i++) a[1][0][i] = a[0][0][i];
	for (i=0;i<3;i++) a[0][0][i] = t[0][i];
}

void print() ;

void turn2 ( char c ) {
	int i , j , k;
	
	for (i=0;i<6;i++)
		for (j=0;j<3;j++)
			for (k=0;k<3;k++)
				b[i][j][k] = a[ perm[ c - 'x' ][i] ][j][k];
	
	for (i=0;i<6;i++)
		for (j=0;j<3;j++)
			for (k=0;k<3;k++)
				a[i][j][k] = b[i][j][k];
	
	if ( c == 'x' ) {
		flip ( 4 ); flip ( 5 );
		rot2 ( 1 );	rot1 ( 3 );
	}
	if ( c == 'y' ) {
		rot2 ( 4 ); rot1 ( 5 );
	}
	if ( c == 'z' ) {
		rot2 ( 0 ); rot1 ( 1 ); rot1 ( 2 ); rot2 ( 3 ); rot2 ( 4 );
		rot1 ( 5 );
	}
}

void solve() {
	char c;
	
	flip ( 5 );
	
	while ( scanf ("%c",&c) , c != '\n' ) {
		if ( isdigit ( c ) )
			while ( c != '0' ) {
				turn1();
				-- c;
			}
		else
			turn2 ( c );
	}
}

void print() {
	int i , j , k;
	
	flip ( 5 );
	
	for (i=0;i<3;i++) {
		for (j=0;j<3;j++) printf (" ");
		for (j=0;j<3;j++)
			printf ("%c",a[4][i][j]);
		printf ("\n");
	}
	
	for (i=0;i<3;i++) {
		for (j=0;j<3;j++) printf ("%c",a[3][i][j]);
		for (j=0;j<3;j++) printf ("%c",a[0][i][j]);
		for (j=0;j<3;j++) printf ("%c",a[1][i][j]);
		for (j=0;j<3;j++) printf ("%c",a[2][i][j]);
		printf ("\n");
	}
	
	for (i=0;i<3;i++) {
		for (j=0;j<3;j++) printf (" ");
		for (j=0;j<3;j++)
			printf ("%c",a[5][i][j]);
		printf ("\n");
	}
}

int main() {
	read();
	solve();
	print();
	
	return 0;
}
