#include <stdio.h>
#include <string>
using namespace std;

char R[5][3][4];

void flipVert(char a[3][4])
{
     for (int i = 0; i < 3; i++) swap(a[0][i], a[2][i]);
}

void flipHor(char a[3][4])
{
     for (int i = 0; i < 3; i++) swap(a[i][0], a[i][2]);
}

void rotate90(char a[3][4])
{
     char save = a[0][0];
     a[0][0] = a[0][2];
     a[0][2] = a[2][2];
     a[2][2] = a[2][0];
     a[2][0] = save;
     save = a[0][1];
     a[0][1] = a[1][2];
     a[1][2] = a[2][1];
     a[2][1] = a[1][0];
     a[1][0] = save;
}

void turnX()
{
     char save[3][4];
     memcpy(save, R[3], sizeof(save));
     memcpy(R[3], R[5], sizeof(save));
     memcpy(R[5], R[1], sizeof(save));
     memcpy(R[1], R[4], sizeof(save));
     memcpy(R[4], save, sizeof(save));
     
     flipVert(R[4]); flipHor(R[4]);
     flipVert(R[3]); flipHor(R[3]);
     for (int i = 0; i < 3; i++) rotate90(R[0]);
     rotate90(R[2]);
}

void turnY()
{
     char save[3][4];
     memcpy(save, R[3], sizeof(save));
     memcpy(R[3], R[2], sizeof(save));
     memcpy(R[2], R[1], sizeof(save));
     memcpy(R[1], R[0], sizeof(save));
     memcpy(R[0], save, sizeof(save));
     
     rotate90(R[4]);
     for (int i = 0; i < 3; i++) rotate90(R[5]);
}

void turnZ()
{
     char save[3][4];
     memcpy(save, R[4], sizeof(save));
     memcpy(R[4], R[2], sizeof(save));
     memcpy(R[2], R[5], sizeof(save));
     memcpy(R[5], R[0], sizeof(save));
     memcpy(R[0], save, sizeof(save));
     
     rotate90(R[4]);
     rotate90(R[0]);
     rotate90(R[5]);
     rotate90(R[2]);
     rotate90(R[1]);
     for (int i = 0; i < 3; i++) rotate90(R[3]);
     
}

void turn90()
{
     char save[4];
     memcpy(save, R[3][0], sizeof(save));
     memcpy(R[3][0], R[2][0], sizeof(save));
     memcpy(R[2][0], R[1][0], sizeof(save));
     memcpy(R[1][0], R[0][0], sizeof(save));
     memcpy(R[0][0], save, sizeof(save));
     
     rotate90(R[4]);
}
void printCube()
{
     for (int i = 0; i < 3; i++)
     {
         for (int j = 0; j < 3; j++) printf(" ");
         for (int j = 0; j < 3; j++) printf("%c", R[4][i][j]);
         printf("\n");
     }
     for (int i = 0; i < 3; i++)
     {
         for (int j = 0; j < 4; j++)
          for (int q = 0; q < 3; q++)
           printf("%c", R[j][i][q]);
         printf("\n");
     }
     for (int i = 0; i < 3; i++)
     {
         for (int j = 0; j < 3; j++) printf(" ");
         for (int j = 0; j < 3; j++) printf("%c", R[5][i][j]);
         printf("\n");
     }
}

void readCube()
{
     for (int i = 0; i < 3; i++)
     {
         for (int j = 0; j < 3; j++) scanf(" ");
         for (int j = 0; j < 3; j++) scanf("%c", &R[4][i][j]);
         scanf("\n");
     }
     for (int i = 0; i < 3; i++)
     {
         for (int j = 0; j < 4; j++)
          for (int q = 0; q < 3; q++)
           scanf("%c", &R[j][i][q]);
         scanf("\n");
     }
     for (int i = 0; i < 3; i++)
     {
         for (int j = 0; j < 3; j++) scanf(" ");
         for (int j = 0; j < 3; j++) scanf("%c", &R[5][i][j]);
         scanf("\n");
     }
}
int main()
{
    readCube();
    
    while (1)
    {
          char c;
          scanf("%c", &c);
          if (c == '\n') break;
          
          if (c == 'x') turnX();
          else if (c == 'y') turnY();
          else if (c == 'z') turnZ();
          else 
          {
               for (int i = 0; i < c - '0'; i++)
                turn90();
          }
    }
    printCube();
    return 0;
}
